<?php

if (!defined('ABSPATH')) exit;


add_settings_section('argus-oauth2-authorisation-section', '', function() {}, 'argus-discord-plugin-settings');


add_settings_field('argus-discord-oauth2-client-id-field', __("Client ID", 'argus-wordpress-plugin'), function() {
    ?>
    <input type="text"
           id="argus-discord-oauth2-client-id"
           class="regular-text"
           name="argusDiscordOAuth2ClientID"
           required
           autocomplete="off"
           pattern="[0-9]+"
           title="<?php _e("Client ID must contain only numbers.", 'argus-wordpress-plugin'); ?>">
    <p class="description">
        <?php _e("Look like: 693415627989705022", 'argus-wordpress-plugin'); ?>
    </p>
    <?php
}, 'argus-discord-plugin-settings', 'argus-oauth2-authorisation-section', ['label_for' => 'argus-discord-oauth2-client-id']);


add_settings_field('argus-discord-oauth2-client-secret-field', __("Client Secret", 'argus-wordpress-plugin'), function() {
    ?>
    <input type="text"
           id="argus-discord-oauth2-client-secret"
           class="regular-text"
           name="argusDiscordOAuth2ClientSecret"
           required
           autocomplete="off"
           pattern="^\S*$"
           title="<?php _e("Spaces are not allowed.", 'argus-wordpress-plugin'); ?>">
    <p class="description">
        <?php _e("Look like: uabUEweqJgsvDfIYM3LP4_L29y2swF5s", 'argus-wordpress-plugin'); ?>
    </p>
    <?php
}, 'argus-discord-plugin-settings', 'argus-oauth2-authorisation-section', ['label_for' => 'argus-discord-oauth2-client-secret']);


add_settings_field('argusDiscordOAuth2BotToken-field', __("Bot Token", 'argus-wordpress-plugin'), function() {
    ?>
    <input type="text"
           id="argus-discord-oauth2-bot-token"
           class="regular-text"
           name="argusDiscordOAuth2BotToken"
           required
           autocomplete="off"
           pattern="^\S*$"
           title="<?php _e("Spaces are not allowed.", 'argus-wordpress-plugin'); ?>">
    <p class="description">
        <?php _e("Look like: Njk4MJgsvDyOTM1NzY1MDIy.XpL4RA.g3ceVTM1yhV-L-kU4g6J32mvpWI4", 'argus-wordpress-plugin'); ?>
    </p>
    <?php
}, 'argus-discord-plugin-settings', 'argus-oauth2-authorisation-section', ['label_for' => 'argus-discord-oauth2-bot-token']);
