<?php

namespace Argus\Discord;

if (!defined('ABSPATH')) exit;


add_shortcode('argus-discord-chat-shortcode', function($attributes) {

    if (!$attributes || !is_array($attributes)) $attributes = [];

    $instance['color']               = 'argus-discord-widget--theme-' . ($attributes['color'] ?? 'light');
    $instance['channel']             = $attributes['channel'] ?? 0;
    $instance['title']               = $attributes['title'] ?? __("Discord Chat", 'argus-wordpress-plugin');
    $instance['pinnedMessages']      = isset($attributes['pinned-messages']) && $attributes['pinned-messages'] == 'onlyPinned';
    $instance['tenorMessages']       = !isset($attributes['tenor-messages']) || $attributes['tenor-messages'] == 'video';
    $instance['imageMessages']       = !isset($attributes['image-messages']) || $attributes['image-messages'] == 'image';
    $instance['linkMessages']        = !isset($attributes['link-messages']) || $attributes['link-messages'] == 'link';
    $instance['customEmojiMessages'] = !isset($attributes['custom-emoji-messages']) || $attributes['custom-emoji-messages'] == 'image';
    $instance['quantity']            = (isset($attributes['quantity']) && ($attributes['quantity'] >= 1 && $attributes['quantity'] <= 50)) ? $attributes['quantity'] : 20;
    $instance['height']              = (isset($attributes['height']) && $attributes['height'] >= 200) ? $attributes['height'] : 200;
    $instance['link']                = $attributes['link'] ?? 0;
    $instance['footerText']          = $attributes['footer-text'] ?? __("Hangout with people who get it", 'argus-wordpress-plugin');
    $instance['className']           = '';

    $filter   = [
        'customEmoji' => $instance['customEmojiMessages'],
        'images'      => $instance['imageMessages'],
        'links'       => $instance['linkMessages'],
        'tenor'       => $instance['tenorMessages']
    ];
    $messages = Data::getAllMessagesData($instance['channel'], $instance['quantity'], $instance['pinnedMessages']);
    $invite   = $instance['link'] ? Data::getInviteLink($instance['link']) : false;

    wp_enqueue_style('argus-discord-front-end-styles');

    ob_start();
    require ARGUS_DISCORD_PLUGIN_PATH . 'widgets/chat/chat.phtml';
    return ob_get_clean();
});
