<?php

namespace Argus\Discord;

if (!defined('ABSPATH')) exit;


add_action('enqueue_block_editor_assets', function() {
    wp_enqueue_style('argus-frontend-styles', ARGUS_DISCORD_PLUGIN_URL . 'views/styles/frontend.css', [], ARGUS_PLUGIN_VERSION);
});


add_action('init', function() {

    Gutenberg::init('connect-profile');

    register_block_type('argus-wordpress-plugin/argus-discord-connect-profile-gutenberg-block', [
        'editor_script'   => 'argus-discord-connect-profile-gutenberg-block',
        'render_callback' => function($instance) {
            $userID = get_current_user_id();
            if (!$userID) return '';

            $discordID = get_user_meta($userID, 'dwpp-discord-id', true);

            if ($discordID) {
                $text = $instance['disconnectText'] ?? __("Disconnect Discord Profile", 'argus-wordpress-plugin');
            } else {
                $text = $instance['connectText'] ?? __("Connect Discord Profile", 'argus-wordpress-plugin');
            }

            $instance['className'] = $instance['className'] ?? '';

            if (strpos($instance['className'], 'is-style-no') === false) {
                wp_enqueue_style('argus-discord-front-end-styles');
                $instance['className'] .= ' argus-discord__button--default-style';
            }

            if ($discordID) {
                $link = '/?state=argus-disconnect-discord-profile&rand=' . time();
            } else {
                $link = Data::getAuthorizationLink('argus-connect-discord-profile-to-user');
            }

            return '<a class="argus__connect-profile ' . $instance['className'] . '" href="' . $link . '">' . $text . '</a>';
        },
    ]);
});
