<?php

namespace Argus\Discord;

if (!defined('ABSPATH')) exit;


add_shortcode('argus-discord-invite-banner-shortcode', function($attributes) {

    if (!$attributes || !is_array($attributes)) $attributes = [];

    $instance['channel']   = $attributes['channel'] ?? 0;
    $instance['title']     = $attributes['title'] ?? __("Hangout with people who get it", 'argus-wordpress-plugin');
    $instance['showCount'] = !isset($attributes['show-count']) || $attributes['show-count'] == 'show';
    $instance['className'] = '';

    $invite = Data::getInviteLink($instance['channel']);
    if (!$invite) $invite = 'javascript:void(0)';
    $icon         = Data::getDiscordIconURL();
    $membersCount = $instance['showCount'] ? Data::getData('Guild')->approximate_member_count : false;

    wp_enqueue_style('argus-discord-front-end-styles');

    ob_start();
    require ARGUS_DISCORD_PLUGIN_PATH . 'widgets/invite-banner/invite-banner.phtml';
    return ob_get_clean();
});
