<?php

namespace Argus\Discord;

use Elementor\Controls_Manager;
use Elementor\Widget_Base;


class ElementorWidgetInviteLink extends Widget_Base {


    function get_name ():string {
        return 'argus_discord_invite_link_widget';
    }


    function get_title ():string {
        return __("Discord Invite Link", 'argus-wordpress-plugin');
    }


    function get_icon ():string {
        return 'argus-discord-icon-invite-link';
    }


    function get_categories ():array {
        return ['argus-discord-category'];
    }


    protected function register_controls () {
        $channel_objects = Data::getAllChannelsList();

        $channels = [];

        foreach ($channel_objects as $channel) {
            $channels[ $channel->id ] = $channel->name;
        }

        $this->start_controls_section('section_content', [
            'label' => __("Main", 'argus-wordpress-plugin'),
            'tab'   => Controls_Manager::TAB_CONTENT,
        ]);

        $this->add_control('channel', [
            'label'   => __("Invite to channel", 'argus-wordpress-plugin'),
            'type'    => Controls_Manager::SELECT,
            'default' => count($channel_objects) ? $channel_objects[0]->id : '',
            'options' => $channels,
        ]);

        $this->add_control('text', [
            'label'   => __("Link text", 'argus-wordpress-plugin'),
            'type'    => Controls_Manager::TEXT,
            'default' => __("here", 'argus-wordpress-plugin'),
        ]);

        $this->end_controls_section();
    }


    protected function render () {
        $settings = $this->get_settings_for_display();
        $invite   = Data::getInviteLink($settings['channel']);

        ?>
        <a class="argus__invite-link" href="<?php echo $invite; ?>" target="_blank"><?php echo $settings['text']; ?></a>
        <?php
    }


    protected function content_template () {
        ?>
        <a class="argus__invite-link" href="javascript:void(0)">{{{ settings.text }}}</a>
        <?php
    }


}
