<?php

if (!defined('ABSPATH')) exit;


add_action('wp_ajax_argusSaveOption', 'argusSaveOption');
add_action('wp_ajax_nopriv_argusSaveOption', 'argusSaveOption');
function argusSaveOption () {
    $_POST['optionKey']   = strip_tags($_POST['optionKey']);
    $_POST['optionValue'] = strip_tags($_POST['optionValue']);

    if (isset($_POST['optionFilter']) && is_array($_POST['optionFilter'])) {
        if (in_array('tags_list', $_POST['optionFilter'])) {
            $_POST['optionValue'] = array_filter(explode(',', $_POST['optionValue']), 'strlen');
            $_POST['optionValue'] = implode(',', $_POST['optionValue']);
        }

        if (in_array('strip_slashes', $_POST['optionFilter'])) {
            $_POST['optionValue'] = stripslashes($_POST['optionValue']);
        }
    }

    if (update_option($_POST['optionKey'], $_POST['optionValue'])) {
        wp_send_json_success();
    } else {
        wp_send_json_error(['message' => __("Option not updated, error on the server...", 'argus-wordpress-plugin')]);
    }
    exit;
}


add_action('wp_ajax_argusCheckPurchaseCode', 'argusCheckPurchaseCode');
add_action('wp_ajax_nopriv_argusCheckPurchaseCode', 'argusCheckPurchaseCode');
function argusCheckPurchaseCode () {
    $response = Argus\Data::checkPurchaseCode(strip_tags($_POST['code']));
    wp_send_json_success($response);
    exit;
}


add_action('wp_ajax_argusToggleComponent', 'argusToggleComponent');
add_action('wp_ajax_nopriv_argusToggleComponent', 'argusToggleComponent');
function argusToggleComponent () {
    $name            = strip_tags($_POST['name']);
    $nameCapitalized = ucfirst($name);
    $componentsArray = explode(',', get_option('argusActiveComponents'));

    include_once ARGUS_PLUGIN_PATH . 'components/' . $name . '/controllers/Cron.php';
    include_once ARGUS_PLUGIN_PATH . 'components/' . $name . '/controllers/Activate.php';

    if ($_POST['state'] == 'true') {
        $callMethodDeactivate = 'uninstall' . $nameCapitalized;
        include_once ARGUS_PLUGIN_PATH . 'controllers/Uninstall.php';

        Argus\Uninstall::$callMethodDeactivate();
        foreach (array_keys($componentsArray, $name, true) as $key) {
            unset($componentsArray[ $key ]);
        }

    } else {
        $callStringActivate = 'Argus\\' . $nameCapitalized . '\\Activate';
        $callStringActivate::activate();
        $componentsArray[] = $name;
    }

    $componentsArray = array_filter($componentsArray, 'strlen');

    update_option('argusActiveComponents', implode(',', $componentsArray));
    wp_send_json_success();
    exit;
}


add_action('wp_ajax_argusGetLogs', 'argusGetLogs');
add_action('wp_ajax_nopriv_argusGetLogs', 'argusGetLogs');
function argusGetLogs () {
    $response = Argus\Log::getComponentLogs(intval($_POST['component']));
    wp_send_json_success($response);
    exit;
}


add_action('wp_ajax_argusDownloadUpdateZip', 'argusDownloadUpdateZip');
add_action('wp_ajax_nopriv_argusDownloadUpdateZip', 'argusDownloadUpdateZip');
function argusDownloadUpdateZip () {
    $link = Argus\Data::getDownloadURL();
    if (!$link) {
        wp_send_json_error(['message' => __("Could not retrieve a download link", 'argus-wordpress-plugin')]);
        exit;
    }

    if (Argus\Update::downloadUpdateZip($link) === false) {
        wp_send_json_error(['message' => __("Could not download the update", 'argus-wordpress-plugin')]);
    } else {
        wp_send_json_success(['message' => __("Update downloaded", 'argus-wordpress-plugin')]);
    }
    exit;
}


add_action('wp_ajax_argusUnzipUpdateZip', 'argusUnzipUpdateZip');
add_action('wp_ajax_nopriv_argusUnzipUpdateZip', 'argusUnzipUpdateZip');
function argusUnzipUpdateZip () {
    if (!Argus\Update::unzipUpdateZip()) {
        wp_send_json_error(['message' => __("Could not install the update", 'argus-wordpress-plugin')]);
    } else {
        wp_send_json_success(['message' => __("Update installed", 'argus-wordpress-plugin')]);
    }
    exit;
}


add_action('wp_ajax_argusUpdateDataAfterUpdate', 'argusUpdateDataAfterUpdate');
add_action('wp_ajax_nopriv_argusUpdateDataAfterUpdate', 'argusUpdateDataAfterUpdate');
function argusUpdateDataAfterUpdate () {
    if (!Argus\Update::update()) {
        wp_send_json_error(['message' => __("Could not update data", 'argus-wordpress-plugin')]);
    } else {
        wp_send_json_success(['message' => __("Database updated", 'argus-wordpress-plugin')]);
    }
    exit;
}


add_action('wp_ajax_argusClearUpdateGarbage', 'argusClearUpdateGarbage');
add_action('wp_ajax_nopriv_argusClearUpdateGarbage', 'argusClearUpdateGarbage');
function argusClearUpdateGarbage () {
    Argus\Update::clearUpdateGarbage();
    wp_send_json_success(['message' => __("Outdated and temporary files are cleaned", 'argus-wordpress-plugin')]);
    exit;
}
