<?php

namespace Argus;

class API {

    private static string $authorAPIDomain = 'https://api.mykolapetrovych.com/';


    protected static function requestPurchaseCodeCheck ($purchaseCode) {
        return self::authorAPIRequest('check-purchase', $purchaseCode);
    }


    protected static function requestGetSupportExpireDate ($purchaseCode) {
        return self::authorAPIRequest('get-support-date', $purchaseCode);
    }


    protected static function requestDownloadURL ($purchaseCode) {
        return self::authorAPIRequest('get-download-link', $purchaseCode);
    }


    protected static function requestLastVersion ($purchaseCode) {
        return self::authorAPIRequest('get-item-version', $purchaseCode);
    }


    private static function authorAPIRequest ($request, $purchaseCode) {
        $curl = curl_init(self::$authorAPIDomain . "envato/$request.php");
        curl_setopt($curl, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode(['item' => ARGUS_ENVATO_ID, 'code' => $purchaseCode, 'domain' => $_SERVER['SERVER_NAME']], JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE));
        curl_setopt($curl, CURLOPT_HTTPHEADER, [
            'Content-Type: application/json',
            'Accept: application/json',
        ]);

        $response     = json_decode(curl_exec($curl));
        $responseCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        curl_close($curl);

        if ($responseCode != 200) {
            return (object)[
                'success' => false,
                'message' => __("Can not connect to the server, contact support", 'argus-wordpress-plugin')
            ];
        }

        return $response;
    }

}
